'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateInput = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _containers = require('../containers');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function DateInput(props) {
  var onChange = props.onChange,
      value = props.value,
      className = props.className,
      placeholder = props.placeholder;

  var onDateChange = function onDateChange(newDate) {
    onChange(newDate.format('DD-MM-YYYY'));
  };

  var inputElement = _react2.default.createElement(_semanticUiReact.Input, {
    className: className,
    value: value,
    placeholder: placeholder,
    icon: 'calendar',
    iconPosition: 'left',
    type: 'text' });
  return _react2.default.createElement(
    _semanticUiReact.Popup,
    {
      on: 'click',
      className: 'suir-calendar popup',
      hoverable: true,
      trigger: inputElement },
    _react2.default.createElement(_containers.DatePicker, {
      onDateChange: onDateChange })
  );
}

DateInput.propTypes = {
  /** (value) => {} where value has format 'DD-MM-YYYY' */
  onChange: _propTypes2.default.func,
  /** selected date value in format 'DD-MM-YYYY' */
  value: _propTypes2.default.string,
  className: _propTypes2.default.string,
  placeholder: _propTypes2.default.string
};

DateInput.defaultProps = {
  value: '',
  placeholder: ''
};

exports.default = DateInput;
exports.DateInput = DateInput;