'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatePickerComponent = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DatePickerCell = require('./DatePickerCell.js');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _utils = require('../utils.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function DatePickerComponent(props) {
  var onDateClick = props.onDateClick,
      activeDate = props.activeDate,
      showedMonth = props.showedMonth,
      className = props.className;

  var data = (0, _utils.getArrayOfWeeks)(showedMonth);
  var _getRow = function _getRow(week, key) {
    var days = week.map(function (day) {
      var active = (0, _utils.compareDates)(day, activeDate);
      var disabled = !(0, _utils.isDayInMonth)(day, showedMonth);
      return _react2.default.createElement(
        _DatePickerCell.DatePickerCell,
        {
          onClick: onDateClick.bind(null, day),
          active: active,
          disabled: disabled,
          key: day.format('DD-MM-YYYY') },
        day.format('D')
      );
    });
    return _react2.default.createElement(
      _semanticUiReact.Table.Row,
      { key: key },
      days
    );
  };

  var _getTableContent = function _getTableContent(weeks) {
    return weeks.map(function (week) {
      return _getRow(week, week[0].format('YYYY-MM-DD'));
    });
  };

  var classes = (0, _classnames2.default)(className);
  return _react2.default.createElement(
    _semanticUiReact.Table.Body,
    null,
    _getTableContent(data)
  );
}

DatePickerComponent.propTypes = {
  /** (clickedDate) => { do something }
   * 
   * @param clickedDate `moment` instance
   */
  onDateClick: _propTypes2.default.func.isRequired,
  /** Currently selected date */
  activeDate: _propTypes2.default.instanceOf(_moment2.default).isRequired,
  /** calendar shows month of this `moment` */
  showedMonth: _propTypes2.default.instanceOf(_moment2.default).isRequired,
  className: _propTypes2.default.string
};

exports.default = DatePickerComponent;
exports.DatePickerComponent = DatePickerComponent;