'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateTimeInput = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _containers = require('../containers');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimeInput = function (_React$Component) {
  _inherits(DateTimeInput, _React$Component);

  function DateTimeInput(props) {
    _classCallCheck(this, DateTimeInput);

    var _this = _possibleConstructorReturn(this, (DateTimeInput.__proto__ || Object.getPrototypeOf(DateTimeInput)).call(this, props));

    _this.componentDidUpdate = function (prevProps, prevState) {
      var _this$state = _this.state,
          selectedDate = _this$state.selectedDate,
          selectedTime = _this$state.selectedTime;

      var filled = selectedDate && selectedTime;
      var updated = selectedDate !== prevState.selectedDate || selectedTime !== prevState.selectedTime;
      if (filled && updated) {
        _this.props.onChange(selectedDate + ' ' + selectedTime);
      }
    };

    _this.onDateChange = function (newDate) {
      _this.setState({
        selectedDate: newDate.format('DD-MM-YYYY')
      });
    };

    _this.onTimeChange = function (newTime) {
      _this.setState({
        selectedTime: newTime
      });
    };

    _this.state = {
      selectedDate: '',
      selectedTime: ''
    };
    return _this;
  }

  _createClass(DateTimeInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          className = _props.className,
          placeholder = _props.placeholder;


      var inputElement = _react2.default.createElement(_semanticUiReact.Input, {
        placeholder: placeholder,
        className: className,
        value: value,
        icon: 'calendar',
        iconPosition: 'left',
        type: 'text' });
      return _react2.default.createElement(
        _semanticUiReact.Popup,
        {
          on: 'click',
          className: 'suir-calendar popup',
          hoverable: true,
          trigger: inputElement },
        _react2.default.createElement(_containers.DateTimePicker, {
          onDateChange: this.onDateChange,
          onTimeChange: this.onTimeChange })
      );
    }
  }]);

  return DateTimeInput;
}(_react2.default.Component);

DateTimeInput.propTypes = {
  /** (value) => {} where value has format 'DD-MM-YYYY hh:mm' */
  onChange: _propTypes2.default.func,
  /** selected date and time value in format 'DD-MM-YYYY hh:mm' */
  value: _propTypes2.default.string,
  className: _propTypes2.default.string,
  placeholder: _propTypes2.default.string
};

DateTimeInput.defaultProps = {
  value: '',
  placeholder: ''
};

exports.default = DateTimeInput;
exports.DateTimeInput = DateTimeInput;