'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HourPicker = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils.js');

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function HourPicker(props) {
  var onTimeClick = props.onTimeClick,
      activeHour = props.activeHour;

  var hours = (0, _utils.getHours)().map(function (hour) {
    return _react2.default.createElement(
      _semanticUiReact.Table.Cell,
      {
        onClick: onTimeClick.bind(null, hour),
        className: 'suir-calendar time',
        active: hour === activeHour,
        textAlign: 'center',
        key: hour },
      hour + ':00'
    );
  });
  var rows = function () {
    var rows = [];
    var rowIndex = 0;
    for (var i = 0; i < hours.length; i++) {
      if (i % 4 === 0 && i !== 0) {
        rowIndex += 1;
      }
      if (!rows[rowIndex]) {
        rows[rowIndex] = [];
      }
      rows[rowIndex].push(hours[i]);
    }
    return rows;
  }().map(function (row, i) {
    return _react2.default.createElement(
      _semanticUiReact.Table.Row,
      { key: i },
      row
    );
  });
  return _react2.default.createElement(
    _semanticUiReact.Table.Body,
    null,
    rows
  );
}

HourPicker.propTypes = {
  /** (clickedTime) => do somthing
   * 
   * @param clickedTime {string} 'hh'
   */
  onTimeClick: _propTypes2.default.func.isRequired,
  activeHour: _propTypes2.default.string
};

exports.default = HourPicker;
exports.HourPicker = HourPicker;