'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MinutePicker = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils.js');

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function MinutePicker(props) {
  var onTimeClick = props.onTimeClick,
      hour = props.hour,
      activeMinute = props.activeMinute;

  var minutes = (0, _utils.getMinutes)().map(function (minute) {
    return _react2.default.createElement(
      _semanticUiReact.Table.Cell,
      {
        onClick: onTimeClick.bind(null, minute),
        className: 'suir-calendar time',
        active: minute === activeMinute,
        textAlign: 'center',
        key: minute },
      hour + ':' + minute
    );
  });
  var rows = function () {
    var rows = [];
    var rowIndex = 0;
    for (var i = 0; i < minutes.length; i++) {
      if (i % 3 === 0 && i !== 0) {
        rowIndex += 1;
      }
      if (!rows[rowIndex]) {
        rows[rowIndex] = [];
      }
      rows[rowIndex].push(minutes[i]);
    }
    return rows;
  }().map(function (row, i) {
    return _react2.default.createElement(
      _semanticUiReact.Table.Row,
      { key: i },
      row
    );
  });
  return _react2.default.createElement(
    _semanticUiReact.Table.Body,
    null,
    rows
  );
}

MinutePicker.propTypes = {
  /** (clickedTime) => do somthing
   * 
   * @param clickedTime {string} 'mm'
   */
  onTimeClick: _propTypes2.default.func.isRequired,
  /** 'hh' */
  hour: _propTypes2.default.string.isRequired,
  activeMinute: _propTypes2.default.string
};

exports.default = MinutePicker;
exports.MinutePicker = MinutePicker;