'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TimeInput = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _containers = require('../containers');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TimeInput(props) {
  var onChange = props.onChange,
      value = props.value,
      className = props.className,
      placeholder = props.placeholder;


  var inputElement = _react2.default.createElement(_semanticUiReact.Input, {
    placeholder: placeholder,
    className: className,
    value: value,
    icon: 'time',
    iconPosition: 'left',
    type: 'text' });
  return _react2.default.createElement(
    _semanticUiReact.Popup,
    {
      on: 'click',
      className: 'suir-calendar popup',
      hoverable: true,
      trigger: inputElement },
    _react2.default.createElement(_containers.TimePicker, {
      onTimeChange: onChange })
  );
}

TimeInput.propTypes = {
  /** (value) => {} where value has format 'hh:mm' */
  onChange: _propTypes2.default.func,
  /** selected time value in format 'hh:mm' */
  value: _propTypes2.default.string,
  className: _propTypes2.default.string,
  placeholder: _propTypes2.default.string
};

TimeInput.defaultProps = {
  value: '',
  placeholder: ''
};

exports.default = TimeInput;
exports.TimeInput = TimeInput;