'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TimePickerComponent = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ = require('.');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TimePickerComponent(props) {
  var selectedDate = props.selectedDate,
      onNextDayBtnClick = props.onNextDayBtnClick,
      onPrevDayBtnClick = props.onPrevDayBtnClick,
      onHourClick = props.onHourClick,
      onMinuteClick = props.onMinuteClick,
      activeHour = props.activeHour,
      activeMinute = props.activeMinute;

  if (activeHour) {
    return _react2.default.createElement(
      _react2.default.Fragment,
      null,
      selectedDate && _react2.default.createElement(_.DateTimePickerHeader, {
        width: '3',
        showWeeks: false,
        showDate: true,
        showedDate: selectedDate,
        onNextBtnClick: onNextDayBtnClick,
        onPrevBtnClick: onPrevDayBtnClick }),
      _react2.default.createElement(_.MinutePicker, {
        hour: activeHour,
        activeMinute: activeMinute,
        onTimeClick: onMinuteClick })
    );
  } else {
    return _react2.default.createElement(
      _react2.default.Fragment,
      null,
      selectedDate && _react2.default.createElement(_.DateTimePickerHeader, {
        width: '4',
        showWeeks: false,
        showDate: true,
        showedDate: selectedDate,
        onNextBtnClick: onNextDayBtnClick,
        onPrevBtnClick: onPrevDayBtnClick }),
      _react2.default.createElement(_.HourPicker, {
        activeHour: activeHour,
        onTimeClick: onHourClick })
    );
  }
}

TimePickerComponent.propTypes = {
  onHourClick: _propTypes2.default.func.isRequired,
  onMinuteClick: _propTypes2.default.func.isRequired,
  /** Show date in header if given */
  selectedDate: _propTypes2.default.instanceOf(_moment2.default),
  activeHour: _propTypes2.default.string,
  activeMinute: _propTypes2.default.string,
  onNextDayBtnClick: _propTypes2.default.func,
  onPrevDayBtnClick: _propTypes2.default.func
};

exports.default = TimePickerComponent;
exports.TimePickerComponent = TimePickerComponent;